/*******************************************************************
plik biblioteczny obslugi przetwornika analogowo-cyfrowego
kontroler: ATmega16
zrodlo napiecia odniesienia: wewnetrzne
*******************************************************************/

//inicjalizacja przetwornika analogowo-cyfrowego
void ADC_init(void)
{
    DDRA&=~(1<<7);
    PORTA&=~(1<<7);
	PORTA=0;
	//ADMUX = (1 <<ADLAR) | (1<<REFS1) | (1<<REFS0);    // nr wejscia - port A, adjustowanie wyniku do lewej, zrodlo napiecia odniesienia wewnetrzne
    //ADMUX = (1 <<ADLAR) | (1<<REFS0);    // nr wejscia - port A, adjustowanie wyniku do lewej, zrodlo napiecia odniesienia wewnetrzne
    //ADMUX = (1<<REFS1) | (1<<REFS0);
	ADMUX = (1<<REFS0) | 0x07;
	//REFS1=0, REFS0=1 => zrodlem odniesienia byloby AVCC
	ADCSRA = (1 << ADEN) | (1<< ADPS2) | (1<< ADPS1);    // ADC preskaler = 5 => Fadc=8MHz/2^6 = 125kHz   
	//tzw. pusty (dummy) odczyt - pierwszy odczyt po wlaczeniu przetwornika 
	ADCSRA |= (1<<ADSC);        //wykonaj pojedyncza konwersje
	while(!(ADCSRA & 0x10));    // oczekiwanie na zakonczenie konwersji	
}

//wybor wejscia dolaczonego do przetwornika
void ADC_input(uint8_t input)
{
    //zmiana trzech ostatnich bitow selektora kanalu
	ADMUX &= 0b11111000;		//wyzerowanie trzech ostatnich bitow
	ADMUX |= input;    			//ustawienie trzech ostatnich bitow, nr wejscia portu A  
}


//odczyt bajtu z przetwornika analogowo-cyfrowego
//wykorzystywane tylko 8 najstarszych bitow
uint16_t ADC_read(void)
{
    uint16_t wynik =0;
		
    ADCSRA |= (1<<ADSC);        	//wykonanie pojedynczej konwersji
    while(!(ADCSRA & 0x10));  // oczekiwanie na zakonczenie konwersji, ustawienie flagi ADIF
    wynik = ADCL;   	        // odczyt rejestru ADCL, konieczny mimo i wartosc jest ignorowana
    wynik += ((uint16_t)ADCH)<<8;				// odczyt ADCH, nadpisanie zmiennej         
    return wynik;					//zwrocenie wyniku
}
